/* GRPACK.H:       䠩  ᪨ 㭪権.
			 Header file for graphics functions.
*/
extern int in_textmode, X__max, Y__max, drawmode, adaptype;
extern float x_max, y_max, horfact, vertfact;
extern FILE *fplot;

/*    䠩 ਬ  ⫮ 뢮 ᪮
     ଠ樨. ਬ, ணࠬ PLOTHP  
      䠩  ८ࠧ   ᨣ ࠢ -
     ࠭,  ਭ஬  ஬  -
     . 䨪 FILE ।  筮 䠩
     'stdio.h',  ᫥⢨ ⮣   祭
     ।  䠩.

     File for deferred graphics output. For example, program
     PLOTHP can read this file and convert it to output on
     the video screen, a matrix printer, or an HP plotter.
     The identifier FILE is defined in 'stdio.h', which
     must therefore be included prior to the present file.
*/
#ifndef __HUGE__
#error 訡.    'Huge'.
	  /* Use Turbo C huge mem. model.*/
#endif
void initgr(void);
void endgr(void);
void to_text(void);
void move(float x, float y);
void draw(float x, float y);
void imove(int X, int Y);
void idraw(int X, int Y);
void draw_line(int X1, int Y1, int X2, int Y2);
void dot(int X, int Y);
void clearpage(void);
void text(char *str);
void textXY(int X, int Y, char *str);
void printgr(int Xlo, int Xhi, int Ylo, int Yhi);
void setprdim(void);
int IX(float x);
int IY(float y);
int pixlit(int X, int Y);
int iscolor(void);
void wrscr(int line, int col, char *str);
void settxtcursor(int line, int col);
void clearscr(void);