/* SCRTHR:             Screw-thread    ⮢ 孮
*/
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <alloc.h>
#include <process.h>

struct point {float x, y, z;} *p;
FILE *fp;

void p1(int i);
void p1e(int i);
void p3e(int i, int j, int k);
void p4e(int i, int j, int k, int l);
void pr(int a, int b);

main()
{ int i, j, n, N, N2, N3, N4, k, steps, A, B, C, D;
  double pi, theta, phi, R, r, deltaL,
     major, minor, pitch, h, L, L0, offset;
  char str[30], ch;
  pi = 4 * atan(1.0);
  printf  /* "Major diameter: " */
	    ("\n让 : "); scanf("%lf", &major);
  printf  /* "Minor diameter: " */
	    ("   : "); scanf("%lf", &minor);
  printf(
  /* "If the thread really is to be square, we have: */
  /*         pitch = major - minor =                 */
    "\n᫨ 䨫 १   ⮬, \n\n");
  printf("  蠣 = 让  -   = %5.3f\n\n",
  pitch = major - minor);
  printf(
     /*  Then in one revolution, 'pitch' is the distance the */
     /*  screw moves forward, so the imaginary 'square'  has */
     /*  sides of length  h = pitch/2                        */
    "    ࠬ '蠣' ।");
  printf (" ﭨ,\n ஥ ६頥 ,");
  printf (" ⮬  ࠦ  ''\n㤥 ");
  printf ("  ஭  h = 蠣/2 = %5.3f\n\n", pitch/2);

  printf (
      /* Do you want a different pitch,  so that  the thread */
      /* will not be really square (but rectangular)? (Y/N): */
    "    稭 蠣, ⮡ 䨫\n");
  printf (
       "१    ( אַ㣮)? (Y/N): ");
  scanf("%s", str);
  ch = toupper(str[0]);
  if (ch == 'Y')
  { printf( /* "Pitch: " */  ": ");
    scanf("%lf", &pitch);
  }
  h = pitch/2;
  printf(/* Desired length of the screw thread not less than */
   "  ⮢ १  , 祬 %5.3f : ", h);
  scanf("%lf", &L0);
  if (L0 < h) L0 = h;          /* At least a half revolution */
			 /*  ࠩ    */
  printf( /* Number of steps taken in a half revolution: */
	    "᫮ 祪     : ");
  scanf("%d", &k);
  n = 2 * k;
  deltaL = pitch/n;
  steps = (int)(L0/deltaL + 0.5); N = steps + 1;
  N2 = 2*N; N3 = 3*N; N4 = 4*N;
  L = steps * deltaL;
  printf( /* The real length will be: */
	 "᪠  㤥 =  %5.3f\n\n", L);
  printf( /* Name of output file: */
	    " 室 䠩: "); scanf("%s", str);
  fp = fopen(str, "w");
  theta = pi/k;
  R = major/2; r = minor/2;
  A = 4 * N - 1;
  B = A + k - 1;
  C = B + k - 1;
  D = C + k - 1;
  p = (struct point *)malloc((D+k+1)*sizeof(struct point));
  if (p == NULL) {printf( /* Not enough memory */
			     " 墠⠥ "); exit(1);}
  for (i=1; i<=N; i++)         /* Outer helix on upper flank */
		   /*  ᯨࠫ  孥 孮 */
  { phi = (i-1)*theta;
    p[i].x = R * cos(phi);
    p[i].y = R * sin(phi);
    p[i].z = (i-1) * deltaL;
  }
  for (i=N+1; i<=N2; i++)      /* Inner helix on upper flank */
		 /* ७ ᯨࠫ  孥 孮 */
  { p[i].x = p[i-N].x * r/R;
    p[i].y = p[i-N].y * r/R;
    p[i].z = p[i-N].z;
  }
  for (i=N2+1; i<=N3; i++)     /* Outer helix on lower flank */
		    /*  ᯨࠫ   孮 */
  { p[i].x = -p[i-N2].x;
    p[i].y = -p[i-N2].y;
    p[i].z = p[i-N2].z;
  }
  for (i=N3+1; i<=N4; i++)     /* Inner helix on lower flank */
		 /* ७ ᯨࠫ   孮 */
  { p[i].x = p[i-N].x * r/R;
    p[i].y = p[i-N].y * r/R;
    p[i].z = p[i-N].z;
  }
  for (i=A+2; i<=A+k; i++)
			/* Outer half circle in bottom plane */
	       /*  㮪㦭   ᪮ */
  { phi = (i-A-1)*theta;
    p[i].x = R * cos(phi);
    p[i].y = R * sin(phi);
    p[i].z = 0;
  }
  for (i=B+2; i<=B+k; i++)
			/* Inner half circle in bottom plane */
	    /* ७ 㮪㦭   ᪮ */
  { p[i].x = -p[i-B+A].x * r/R;
    p[i].y = -p[i-B+A].y * r/R;
    p[i].z = 0;
  }
  offset = steps * theta;
  while (offset > 2*pi) offset -= 2*pi;
  for (i=C+2; i<=C+k; i++)
			   /* Outer half circle in top plane */
	      /*  㮪㦭  孥 ᪮ */
  { phi = offset + (i-C-1)*theta;
    p[i].x = R * cos(phi);
    p[i].y = R * sin(phi);
    p[i].z = L;
  }
  for (i=D+2; i<=D+k; i++)
			   /* Inner half circle in top plane */
	   /* ७ 㮪㦭  孥 ᪮ */
  { p[i].x = -p[i-D+C].x * r/R;
    p[i].y = -p[i-D+C].y * r/R;
    p[i].z = L;
  }
  for (i=1; i<=D+k; i++)
    fprintf(fp, "%4d %f %f %f\n",
                 i, p[i].x, p[i].y, p[i].z);

  fprintf(fp, "Faces = ࠭ :\n");         /* ࠭ */

  /* z = 0: */
  p1(N2+1); pr(A+k, A+2); p1(1); p1(N+1);
  pr(B+k, B+2); p1e(N3+1);

  /* z = L: */
  p1(N); pr(C+2, C+k); p1(N3); p1(N4);
  pr(D+2, D+k); p1e(N2);

			/* First 180 degrees (at the bottom) */
			/*  180 ࠤᮢ (᭨)       */

		/* Outer surface: */  /*  孮 */
  p3e(1, A+2, 2);
  for (j=2; j<k; j++) p4e(A+j, A+j+1, j+1, j);
  p4e(A+k, N2+1, k+1, k);

	    /* Inner surface: */   /* ७ 孮 */
  p3e(B+2, N3+2, N3+1);
  for (j=2; j<k; j++) p4e(B+j+1, N3+j+1, N3+j, B+j);
  p4e(N+1, N3+k+1, N3+k, B+k);

			   /* Final 180 degrees (at the top) */
			  /* ᫥ 180 ࠤᮢ (ᢥ) */

	     /* Outer surface: */     /*  孮 */
  p3e(N3, C+k, N3-1);
  for (j=2; j<k; j++) p4e(C+k-j+2, C+k-j+1, N3-j, N3-j+1);
  p4e(C+2, N, N3-k, N3-k+1);

  /* Inner surface: */             /* ७ 孮 */
  p3e(D+k, N2-1, N2);
  for (j=2; j<k; j++) p4e(D+k-j+2, D+k-j+1, N2-j, N2-j+1);
  p4e(D+2, N4, N2-k, N2-k+1);

		      /* Middle part */     /* ।  */

	     /* Outer surface: */     /*  孮 */
  for (j=1; j<N-k; j++) p4e(N2+j, N2+j+1, k+j+1, k+j);

	   /* Inner surface: */    /* ७ 孮 */
  for (j=1; j<N-k; j++) p4e(N+j, N+j+1, N3+k+j+1, N3+k+j);

		   /* Upper flank: */     /*  ஭ */
  for (j=1; j<N; j++)
  { p3e(j, N+j+1, N+j);
    p3e(N+j+1, j, j+1);
  }

		    /* Lower flank: */     /*  ஭ */
  for (j=1; j<N; j++)
  { p3e(N3-j+1, N4-j, N4-j+1);
    p3e(N4-j, N3-j+1, N3-j);
  }
  fclose (fp);
}

void p1(int i)
{ fprintf(fp, " %d", i);
}

void p1e(int i)
{ fprintf(fp, " %d.\n", i);
}

void p3e(int i, int j, int k)
{ fprintf(fp, " %d %d %d.\n", i, j, k);
}

void p4e(int i, int j, int k, int l)
{ fprintf(fp, " %d %d %d %d.\n", i, j, k, l);
}

void pr(int a, int b)
{ int i;
  if (b >= a) for (i=a; i<=b; i++) fprintf(fp, " %d", i);
         else for (i=a; i>=b; i--) fprintf(fp, " %d", i);
}